#include "ofApp.h"

void ofApp::setup() {
    
    ofEnableAlphaBlending();
    
    colorMatte.allocate(960, 540, OF_IMAGE_COLOR_ALPHA);
    colorMatte.load("colormatte.png");
    
    storm.load("storm.mp4");
    redInMatte.load("red-in-matte.mp4");
    stormOutMatte.load("storm-out-matte.mp4");
    
    storm.play();
    storm.setPosition(.4f);
    redInMatte.play();
    stormOutMatte.play();
    
}

//--------------------------------------------------------------
void ofApp::update(){
    // storm cloud shrinks
    storm.update();
    
    // if storm out matte hasnt started playing yet...
    if (!stormOutMatte.isPlaying()) {
        stormOutMatte.play();
    }
    
    stormOutMatte.update();
    
    // same goes for red in matte...
    if (!redInMatte.isPlaying()) {
        redInMatte.play();
    }
    
    redInMatte.update();
}

//--------------------------------------------------------------
void ofApp::draw(){
    // storm goes OUT
    storm.getTexture().setAlphaMask(stormOutMatte.getTexture());
    storm.draw(0, 0, ofGetWidth(), ofGetHeight());
    
    // red comes IN
    colorMatte.getTexture().setAlphaMask(redInMatte.getTexture());
    colorMatte.draw(0, 0, ofGetWidth(), ofGetHeight());
}